DIM STRING N1$, E2$, S3$, S4$             
DIM STRING prgBanks$, chrBanks$, prgRamSize$ 
DIM INTEGER mapperID, map1, map2, mirror, prgSize, chrSize, boolEmulation, inputDigit
DIM INTEGER CARTDATA, I
DIM STRING FileName, InputChar, HexChar, Hex, romInput

'FILE INPUT ROUTINE BORROWED FROM HEXDUMP.BAS FROM CMM1 LIBRARY.
SUB LOADROM() 
CLS
?@ (0,16) "Enter NES ROM: " ; 
Line Input FileName$
Open FileName$ For INPUT As #1
For i = 0 To 15
  InputChar$ = Input$(1,#1)
  HexChar$ = Hex$(Asc(InputChar$))
  If Len(HexChar$) = 1 Then
  HexChar$ = "0" + HexChar$
  EndIf
  select case (i)
  case 0  : N1$ = HexChar$           : PRINT "N         : "; HexChar$
  case 1  : E2$ = HexChar$           : PRINT "E         : "; HexChar$
  case 2  : S3$ = HexChar$           : PRINT "S         : "; HexChar$
  case 3  : S4$ = HexChar$           : PRINT "1A        : "; HexChar$
  case 4  : prgBanks$ = HexChar$     : PRINT "PRG_BANKS : "; val(prgBanks$)
  case 5  : chrBanks$ = HexChar$     : PRINT "CHR_BANKS : "; val(chrBanks$)
  case 6  : map1 = asc(inputchar$)   : PRINT "TVsys1    : "; asc(inputchar$)
  case 7  : map2 = asc(inputchar$)   : PRINT "TVsys2    : "; asc(inputchar$)
  case 8  : prgRamSize$ = HexChar$   : PRINT "PRGram    : "; HexChar$
  case 9  : mirror = asc(inputchar$) : PRINT "MIRROR    : "; asc(inputchar$)
  case 10 : 
  case 11 : 
  case 12 :
  case 13 : 
  case 14 :
  case 15 :
  end select
Next i
  rominput$ = N1$ + E2$ + S3$ + S4$
If rominput$ = "4E" + "45" + "53" + "1A" Then
PRINT "THIS ROM IS VALID"
  prgSize% = 1 * 16384 * val(prgBanks$) - 1
  IF CHRBANKS$ > "00" THEN
    chrSize% = 8192 * val(chrBanks$) - 1
  ELSE
    CHRSIZE% = 8192 - 1
  END IF
PRINT "PRG       : " ; prgsize% ; "KB"
PRINT "CHR       : " ; chrsize% ; "KB"
PAUSE(250)
  mapperID = ((map2) AND &HF0) OR ((map1) >> 4)
  mirror = (map1) AND &H01
DIM INTEGER vPRGMEMORY%(prgSize%)
for i = 0 to prgsize%
  InputChar$ = Input$(1,#1)
  InputDigit% = ASC(InputChar$)
  vPRGMEMORY%(i) = InputDigit%
Next i

DIM INTEGER vCHRMEMORY%(chrSize%)
for i = 0 to chrsize%
  InputChar$ = Input$(1,#1)
  InputDigit% = ASC(InputChar$)
  vCHRMEMORY%(i) = InputDigit%
Next i
  
CLOSE #1
boolEmulation = 1
ELSE
PRINT "NOT A VALID NES ROM"
End If
end sub

FUNCTION CARTCPUREAD(ADDR, TEMPDATA)
LOCAL INTEGER TEMPADDRESS = 0
  IF(MAPPERCPUREAD(ADDR, TEMPADDRESS)) THEN
    CARTDATA = VPRGMEMORY%(MAPPEDADDRESS)
    CARTCPUREAD = 1
  ELSE
    CARTCPUREAD = 0
  END IF
END FUNCTION 
  
FUNCTION CARTcpuWrite(ADDR, TEMPDATA)
  LOCAL INTEGER TEMPADDRESS = 0
  IF(MAPPERcpuWRITE(addr, TEMPADDRESS, TEMPDATA)) THEN
    vPRGMemory%(mappedAddress) = TEMPDATA
    cartcpuwrite = 1
  ELSE
    cartcpuwrite = 0
  END IF
END FUNCTION

FUNCTION CARTppuRead(ADDR, TEMPdata)
  LOCAL INTEGER TEMPADDRESS = 0
  IF(MAPPERppuRead(addr, TEMPADDRESS)) THEN
    CARTDATA = vCHRMemory%(mappedAddress)
    cartppuread = 1
  ELSE
    cartppuread = 0
  END IF
END FUNCTION  
  
FUNCTION CARTppuWrite(ADDR, TEMPDATA)
  LOCAL INTEGER TEMPADDRESS = 0
  IF(MAPPERppuWRITE(addr, TEMPADDRESS)) THEN
    vCHRMemory%(mappedAddress) = TEMPdata
    cartppuwrite = 1
  ELSE
    cartppuwrite = 0
  END IF
END FUNCTION
