'STATUS
DIM INTEGER VBLANK, SPRZEROHIT, SPROVFL, SUNUSED

'MASK
DIM INTEGER EBLU, EGRN, ERED, GSCL, RNSS, RNBG, RNSL, RNBL

'LOOPY
DIM INTEGER VAUNUSED, VAFY, VANY, VANX, VACY, VACX
DIM INTEGER TAUNUSED, TRFY, TRNY, TRNX, TRCY, TRCX

'CONTROL
DIM INTEGER ENMI, SLVM, SPRS, PBKG, PSPR, INCM, NTX, NTY

DIM INTEGER REG = 0

FUNCTION GETSTAT()
  REG = 0
  REG = REG + (VBLANK << 7)
  REG = REG + (SPRZEROHIT << 6)
  REG = REG + (SPROVFL << 5)
  REG = REG + (SUNUSED << 0)
  GETSTAT = REG
END FUNCTION

SUB SETSTAT(CARTDATA)
  VBLANK = (CARTDATA AND &H80) > 0
  SPRZEROHIT = (CARTDATA AND &H40) > 0
  SPROVFL = (CARTDATA AND &H20) > 0   
  SUNUSED = (CARTDATA AND &H1F)
END SUB

FUNCTION GETMASK()
  REG = 0
  REG = REG +(EBLU << 7)
  REG = REG +(EGRN << 6)
  REG = REG +(ERED << 5)
  REG = REG +(RNSS << 4)
  REG = REG +(RNBG << 3)
  REG = REG +(RNSL << 2)
  REG = REG +(RNBL << 1)
  REG = REG +(GSCL << 0)
  GETMASK = REG
END FUNCTION

SUB SETMASK(CARTDATA)
  EBLU = (CARTDATA AND &H80) > 0
  EGRN = (CARTDATA AND &H40) > 0
  ERED = (CARTDATA AND &H20) > 0
  RNSS = (CARTDATA AND &H10) > 0
  RNBG = (CARTDATA AND &H08) > 0
  RNSL = (CARTDATA AND &H04) > 0
  RNBL = (CARTDATA AND &H02) > 0
  GSCL = (CARTDATA AND &H01) > 0
END SUB

FUNCTION GETVRAM()
  REG = 0
  REG = REG +(VAUNUSED << 15)
  REG = REG +(VAFY << 12)
  REG = REG +(VANY << 11)
  REG = REG +(VANX << 10)
  REG = REG +(VACY << 5)
  REG = REG +(VACX << 0) 
  GETVRAM = REG
END FUNCTION

SUB SETVRAM(CARTDATA)
  VAUNUSED = (CARTDATA AND &H8000) > 0
  VAFY = (CARTDATA AND &H7000) >> 12
  VANY = (CARTDATA AND &H0800) > 0
  VANX = (CARTDATA AND &H0400) > 0
  VACY = (CARTDATA AND &H03E0) >> 5
  VACX = (CARTDATA AND &H001F)
END SUB

FUNCTION GETTRAM()
  REG = 0
  REG = REG +(TAUNUSED << 15)
  REG = REG +(TRFY << 12)
  REG = REG +(TRNY << 11)
  REG = REG +(TRNX << 10)
  REG = REG +(TRCY << 5)
  REG = REG +(TRCX << 0) 
  GETTRAM = REG
END FUNCTION

SUB SETTRAM(CARTDATA)
  TAUNUSED = (CARTDATA AND &H8000) > 0
  TRFY = (CARTDATA AND &H7000) >> 12
  TRNY = (CARTDATA AND &H0800) > 0
  TRNX = (CARTDATA AND &H0400) > 0
  TRCY = (CARTDATA AND &H03E0) >> 5
  TRCX = (CARTDATA AND &H001F)
END SUB

FUNCTION GETCTRL()
  REG = 0
  REG = REG + (ENMI << 7)
  REG = REG + (SLVM << 6)
  REG = REG + (SPRS << 5)
  REG = REG + (PBKG << 4)
  REG = REG + (PSPR << 3)
  REG = REG + (INCM << 2)
  REG = REG + (NTY << 1)
  REG = REG + (NTX << 0)
  GETCTRL = REG
END FUNCTION

SUB SETCTRL(CARTDATA)
  ENMI = (CARTDATA AND &H80) > 0
  SLVM = (CARTDATA AND &H40) > 0
  SPRS = (CARTDATA AND &H20) > 0
  PBKG = (CARTDATA AND &H10) > 0
  PSPR = (CARTDATA AND &H08) > 0
  INCM = (CARTDATA AND &H04) > 0
  NTY = (CARTDATA AND &H02) > 0
  NTX = (CARTDATA AND &H01) > 0
END SUB
